org.springframework.jms.config

## Class AbstractJmsListenerEndpoint

- java.lang.Object
- - org.springframework.jms.config.AbstractJmsListenerEndpoint

All Implemented Interfaces:
  JmsListenerEndpoint

Direct Known Subclasses:
  MethodJmsListenerEndpoint, SimpleJmsListenerEndpoint

    public abstract class AbstractJmsListenerEndpoint
    extends Object
    implements JmsListenerEndpoint

Base model for a JMS listener endpoint.

Since:
  4.1
Author:
  Stephane Nicoll, Juergen Hoeller
See Also:
  `MethodJmsListenerEndpoint`, `SimpleJmsListenerEndpoint`

### Constructor Summary

Constructors
Constructor and Description
`AbstractJmsListenerEndpoint()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected abstract MessageListener` `createMessageListener(MessageListenerContainer container)` Create a `MessageListener` that is able to serve this endpoint for the specified container.
`String` `getConcurrency()` Return the concurrency for the listener, if any.
`String` `getDestination()` Return the name of the destination for this endpoint.
`protected StringBuilder` `getEndpointDescription()` Return a description for this endpoint.
`String` `getId()` Return the id of this endpoint.
`String` `getSelector()` Return the JMS message selector expression, if any.
`String` `getSubscription()` Return the name for the durable subscription, if any.
`void` `setConcurrency(String concurrency)` Set a concurrency for the listener, if any.
`void` `setDestination(String destination)` Set the name of the destination for this endpoint.
`void` `setId(String id)`
`void` `setSelector(String selector)` Set the JMS message selector expression.
`void` `setSubscription(String subscription)` Set the name for the durable subscription.
`void` `setupListenerContainer(MessageListenerContainer listenerContainer)` Setup the specified message listener container with the model defined by this endpoint.
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### AbstractJmsListenerEndpoint

    public AbstractJmsListenerEndpoint()

### Method Detail

#### setId

    public void setId(String id)

#### getId

    public String getId()

Description copied from interface: `JmsListenerEndpoint`
Return the id of this endpoint.

Specified by:
  `getId` in interface `JmsListenerEndpoint`

#### setDestination

    public void setDestination(@Nullable
                               String destination)

Set the name of the destination for this endpoint.

#### getDestination

    @Nullable
    public String getDestination()

Return the name of the destination for this endpoint.

#### setSubscription

    public void setSubscription(@Nullable
                                String subscription)

Set the name for the durable subscription.

#### getSubscription

    @Nullable
    public String getSubscription()

Return the name for the durable subscription, if any.

#### setSelector

    public void setSelector(@Nullable
                            String selector)

Set the JMS message selector expression.

See the JMS specification for a detailed definition of selector expressions.

#### getSelector

    @Nullable
    public String getSelector()

Return the JMS message selector expression, if any.

#### setConcurrency

    public void setConcurrency(@Nullable
                               String concurrency)

Set a concurrency for the listener, if any.

The concurrency limits can be a "lower-upper" String, e.g. "5-10", or a simple upper limit String, e.g. "10" (the lower limit will be 1 in this case).

The underlying container may or may not support all features. For instance, it may not be able to scale: in that case only the upper value is used.

#### getConcurrency

    @Nullable
    public String getConcurrency()

Return the concurrency for the listener, if any.

#### setupListenerContainer

    public void setupListenerContainer(MessageListenerContainer listenerContainer)

Description copied from interface: `JmsListenerEndpoint`
Setup the specified message listener container with the model defined by this endpoint.

This endpoint must provide the requested missing option(s) of the specified container to make it usable. Usually, this is about setting the `destination` and the `messageListener` to use but an implementation may override any default setting that was already set.

Specified by:
  `setupListenerContainer` in interface `JmsListenerEndpoint`
Parameters:
  `listenerContainer` - the listener container to configure

#### createMessageListener

    protected abstract MessageListener createMessageListener(MessageListenerContainer container)

Create a `MessageListener` that is able to serve this endpoint for the specified container.

#### getEndpointDescription

    protected StringBuilder getEndpointDescription()

Return a description for this endpoint.

Available to subclasses, for inclusion in their `toString()` result.

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`